<template>
  <div>
    <v-navigation-drawer
      app
      v-model="drawer"
      :mini-variant="isMobile ? false : mini"
      :temporary="isMobile"
      :permanent="!isMobile"
    >
      <v-list-item :class="mini ? 'py-1 px-2' : ''">
        <v-list-item-avatar
          @click="isMobile ? (drawer = !drawer) : miniToggle()"
        >
          <v-img
            contain
            aspect-ratio="1.1"
            src="@/assets/yogya-logo.png"
          ></v-img>
        </v-list-item-avatar>

        <v-list-item-content>
          <v-list-item-title class="title">
            MyTraining
          </v-list-item-title>
          <v-list-item-subtitle>
            Web Admin
          </v-list-item-subtitle>
        </v-list-item-content>

        <v-btn icon @click.stop="isMobile ? (drawer = !drawer) : miniToggle()">
          <v-icon>mdi-chevron-left</v-icon>
        </v-btn>
      </v-list-item>

      <v-list dense nav shaped class="mt-3">
        <div v-for="access in sidebarData" :key="access.name">
          <v-list-group
            v-if="access.sub !== undefined"
            link
            :to="access.to"
            no-action
            :prepend-icon="access.icon"
            :append-icon="access.hasSub ? undefined : ''"
          >
            <template v-slot:activator>
              <v-list-item-title>{{ access.name }}</v-list-item-title>
            </template>

            <v-list-item
              v-for="subAccess in access.sub"
              :key="subAccess.name"
              link
              exact
              :to="`${access.to}/${subAccess.to}`"
            >
              <v-list-item-content>
                <v-list-item-title>{{ subAccess.name }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list-group>

          <v-list-item v-else link exact :to="access.to">
            <v-list-item-icon>
              <v-icon>{{ access.icon }}</v-icon>
            </v-list-item-icon>

            <v-list-item-content>
              <v-list-item-title>{{ access.name }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </div>
      </v-list>
    </v-navigation-drawer>
    <!-- header -->
    <v-app-bar elevation="0" color="transparent" app>
      <v-spacer></v-spacer>
      <v-menu
        v-model="menu"
        :close-on-content-click="false"
        :nudge-width="100"
        max-width="300"
        offset-x
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn icon class="mx-1" elevation="2" v-bind="attrs" v-on="on">
            <v-avatar width="45" height="45">
              <img
                contain
                src="https://rswijayakusuma.com/wp-content/uploads/2017/12/fb.jpg"
              />
            </v-avatar>
          </v-btn>
        </template>

        <v-card>
          <v-list>
            <v-list-item>
              <v-list-item-content>
                <v-list-item-title>Steve Jobs</v-list-item-title>
                <v-list-item-subtitle>IT</v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-btn class="primary--text" icon>
                  <v-icon>mdi-account-settings</v-icon>
                </v-btn>
              </v-list-item-action>
            </v-list-item>
          </v-list>
          <v-divider></v-divider>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn text @click="onLogout">
              Logout
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-menu>
    </v-app-bar>
  </div>
</template>

<script>
import Cookies from "js-cookie";
import { sidebar } from "@/router/nav";

export default {
  name: "NavNavigationBar",
  data() {
    return {
      mini: false,
      menu: false,
      drawer: false,
      isMobile: false
    };
  },
  computed: {
    sidebarData() {
      return sidebar;
    }
  },
  methods: {
    onResize() {
      this.isMobile = window.innerWidth < 600;
    },
    miniToggle() {
      this.mini = !this.mini;
    },
    onLogout() {
      Cookies.remove("token");
      Cookies.remove("data_user");
      this.$nextTick(() => {
        this.$router.go();
      });
    }
  },
  mounted() {
    this.onResize();

    window.addEventListener("resize", this.onResize, { passive: true });
  },
  beforeDestroy() {
    if (typeof window === "undefined") return;

    window.removeEventListener("resize", this.onResize, { passive: true });
  }
};
</script>
